#include "OgreOcclusionCullingTerrainSceneTraverser.h"
//#include <windows.h>

namespace Ogre {
	//-----------------------------------------------------------------------
	void OcclusionCullingTerrainSceneTraverser::traverseNode( Camera *cam, Octree *node )
	{
		mNumTraversedNodes ++;
	
	/*	if(node->numAttachedObjects() > 0)
		{
			renderSceneNode(cam, node);
		}*/

		for(int i=0; i<8; i++)
		{
			if(node->mChildren[i & 4][i & 2][i & 1] != 0)
				traverseNode(cam, node->mChildren[i & 4][i & 2][i & 1]);
		}
	}
	//-----------------------------------------------------------------------
	void OcclusionCullingTerrainSceneTraverser::renderScene( Camera *cam, Octree *root )
	{
		mNumTraversedNodes = 0;
		mNumQueryCulledNodes = 0;
		mNumFrustumCulledNodes = 0;
		mNumRenderedGeometry = 0;
		
		mDistanceQueue = new OctreePriorityQueue(myless<Octree *>(cam));
//		mDistanceQueue->push(root);
		mCurrentTestIdx = 0;

mCurrentAlgorithm = RENDER_CULL_FRUSTUM;
		switch(mCurrentAlgorithm)
		{
			case RENDER_CULL_FRUSTUM:
				renderCullFrustum(cam);
		        break;
		/*	case RENDER_STOP_AND_WAIT:
				renderStopAndWait(cam);
				break;
			case RENDER_COHERENT:
				renderCoherentWithQueue(cam);
				break;*/
			default:
				renderCullFrustum(cam);
				break;
		}	
		
//		delete mDistanceQueue;

		mFrameId ++;
	}
	//-----------------------------------------------------------------------
	void OcclusionCullingTerrainSceneTraverser::renderCullFrustum(Camera *cam)
	{
		/*while(!mDistanceQueue->empty())
		{
			SceneNode *node = mDistanceQueue->top();
			mDistanceQueue->pop();
	
			// interesting for visualization purpose
			node->setNodeVisible(false);
				
			if(cam->isVisible(node->_getWorldAABB()))
			{
				// update node's visited flag 
				node->setLastVisited(mFrameId);
				node->setNodeVisible(true);
				traverseNode(cam, node);
			}
			else
			{			
				mNumFrustumCulledNodes ++;
			}
		}*/
	}	
	//-----------------------------------------------------------------------
/*	bool OcclusionCullingTerrainSceneTraverser::isLeaf( SceneNode *node )
	{
		return (node->numChildren() == 0);
	}*/
	//-----------------------------------------------------------------------
	void OcclusionCullingTerrainSceneTraverser::pullUpVisibility( Octree *node )
	{
	}
}	
